// PoissonImageDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PoissonImage.h"
#include "PoissonImageDlg.h"
#include ".\poissonimagedlg.h"
#include "ximage.h"
#include "gradImage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CPoissonImageDlg dialog



CPoissonImageDlg::CPoissonImageDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPoissonImageDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPoissonImageDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CPoissonImageDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_LOADIMAGE, OnBnClickedLoadimage)
	ON_BN_CLICKED(IDC_GENERATEMASK, OnBnClickedGeneratemask)
	ON_NOTIFY(NM_RELEASEDCAPTURE, IDC_THRESHOLD, OnNMReleasedcaptureThreshold)
	ON_BN_CLICKED(IDC_GRADIENT, OnBnClickedGradient)
	ON_BN_CLICKED(IDC_GRADX, OnBnClickedGradx)
	ON_BN_CLICKED(IDC_GRADY, OnBnClickedGrady)
END_MESSAGE_MAP()


// CPoissonImageDlg message handlers

BOOL CPoissonImageDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	day = NULL; night = NULL; fused = NULL; mask = NULL;
	threshold = (CSliderCtrl *)(GetDlgItem(IDC_THRESHOLD));
	threshold->SetRange(0, 255, TRUE);
	threshold->SetTicFreq(5);
	threshold->SetPos(127);

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPoissonImageDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPoissonImageDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
		PaintBMP();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPoissonImageDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}
void CPoissonImageDlg::PaintBMP()
{
	if(day == NULL)
		return;
	CxImage* image = new CxImage;
	image->CreateFromArray(day,Width,Height,24,Width * 3, true);
	
	CWnd * imagewnd = (CWnd *) GetDlgItem(IDC_DAY);
	CDC * imagedc = imagewnd->GetDC();	
	RECT recrect;
	imagewnd->GetClientRect(&recrect);
	
	RGBQUAD c={255,255,255,0};
	image->SetTransColor(c);
	image->AlphaStrip();
	image->Stretch(imagedc->GetSafeHdc(), CRect(recrect));
	image->Destroy();


	image->CreateFromArray(night,Width,Height,24,Width * 3, true);
	
	imagewnd = (CWnd *) GetDlgItem(IDC_NIGHT);
	imagedc = imagewnd->GetDC();	
	recrect;
	imagewnd->GetClientRect(&recrect);
	
	image->SetTransColor(c);
	image->AlphaStrip();
	image->Stretch(imagedc->GetSafeHdc(), CRect(recrect));
	image->Destroy();

	image->CreateFromArray(fused,Width,Height,24,Width*3, true);
	
	imagewnd = (CWnd *) GetDlgItem(IDC_FUSE);
	imagedc = imagewnd->GetDC();	
	recrect;
	imagewnd->GetClientRect(&recrect);
	
	image->SetTransColor(c);
	image->AlphaStrip();
	image->Stretch(imagedc->GetSafeHdc(), CRect(recrect));
	image->Destroy();


	image->CreateFromArray(mask,Width,Height,8, Width, true);
	
	imagewnd = (CWnd *) GetDlgItem(IDC_MASK);
	imagedc = imagewnd->GetDC();	
	recrect;
	imagewnd->GetClientRect(&recrect);
	
	//image->SetTransColor(c);
	//image->AlphaStrip();
	image->Stretch(imagedc->GetSafeHdc(), CRect(recrect));
	image->Destroy();
}
void CPoissonImageDlg::OnBnClickedLoadimage()
{
	// TODO: Add your control notification handler code here
	CFileDialog filedlg( TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, NULL, NULL );

	filedlg.DoModal();
	//now check which file to open
	CString name = filedlg.GetFileName();
	CString directory = filedlg.GetPathName();
	if(name.IsEmpty()){
		//message 
		MessageBox("please select the file", NULL, MB_OK);
		return;
	}
	else{
		CString wholepath = directory;
		fp = fopen(wholepath, "r");
		//initial data
		//read in two images
		CBitmap * CBitSrc = new CBitmap;
		BITMAP TmpBMP1;
		char filename[40];
		fscanf(fp, "%s\n", filename);
		HBITMAP hbitmap = (HBITMAP)::LoadImage(AfxGetInstanceHandle(), filename, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
		CBitSrc->Attach(hbitmap);
		CBitSrc->GetBitmap(&TmpBMP1);
		Width = TmpBMP1.bmWidth;
		//Widthbytes =  TmpBMP1.bmWidthBytes;
		Widthbytes =  Width * 3;
		Height = TmpBMP1.bmHeight;
		
		day = new BYTE[Height * Widthbytes];
		CBitSrc->GetBitmapBits((DWORD)(Height * Widthbytes), day);
		CBitSrc->Detach();

		fscanf(fp, "%s\n", filename);
		hbitmap = (HBITMAP)::LoadImage(AfxGetInstanceHandle(), filename, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
		CBitSrc->Attach(hbitmap);
		
		night = new BYTE[Height * Widthbytes];
		CBitSrc->GetBitmapBits((DWORD)(Height * Widthbytes), night);
		CBitSrc->Detach();

		for(int i = 0; i < Width; i ++){
			for(int j = 0; j < Height; j++){
				if(i <= 2 || i >= Width - 3 || j <= 2 || j >= Height -3){
					int pos = j * Widthbytes + 3 * i;
					day[pos] = 0;
					day[pos + 1] = 0;
					day[pos + 2] = 0;
				}
			}
		}

		mask = new BYTE[Height * Width];
		memset(mask, 0, Width * Height);
		rday = new BYTE[Height * Width];
		gday = new BYTE[Height * Width];
		bday = new BYTE[Height * Width];

		rnight = new BYTE[Height * Width];
		gnight = new BYTE[Height * Width];
		bnight = new BYTE[Height * Width];

		fused = new BYTE[Height * Widthbytes];
		gradHxday = new double[Width * Height];gradHyday = new double[Width * Height];
		gradHxnight = new double[Width * Height];gradHynight = new double[Width * Height];

		fclose(fp);

		for(int i = 0; i < Width; i ++){
			for(int j = 0; j < Height; j++){
				int pos = j * Widthbytes + 3 * i;
				int pos1 = j * Width + i;
				rday[pos1] = day[pos];gday[pos1] = day[pos + 1];bday[pos1] = day[pos + 2];
				rnight[pos1] = night[pos];gnight[pos1] = night[pos + 1];bnight[pos1] = night[pos + 2];
			}
		}

		Invalidate(false);
	}
}
void CPoissonImageDlg::GenerateMask()
{
	if(mask == NULL) return;
	int thresholdval = threshold->GetPos();
	memset(mask, 0, Width*Height);
	for(int i = 0; i < Width; i ++){
		for(int j = 0; j < Height; j++){
			//compute the intensity
			int pixelloc = j * Widthbytes + 3 * i;
			int pixelmask = j * Width + i;
			double intensity = (night[pixelloc] + night[pixelloc + 1] + night[pixelloc + 2])/3.0;
			if(intensity >= thresholdval){
				mask[pixelmask] = 255;
			}
		}
	}
}
void CPoissonImageDlg::OnBnClickedGeneratemask()
{
	// TODO: Add your control notification handler code here
	//simply compute and threshold the gradient
	GenerateMask();	
	Invalidate(false);
}

void CPoissonImageDlg::OnNMReleasedcaptureThreshold(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: Add your control notification handler code here
	*pResult = 0;
	GenerateMask();	
	Invalidate(false);
}
void CPoissonImageDlg::IntegrateOneChannel(double * gradHx1, double * gradHy1, BYTE * result)
{
	//compute divG
	double * divG = new double[Width * Height];
	imageGradientTodivG(gradHx1, gradHy1, divG, Width, Height);
	double ** u, ** out;
	int nn = Width - 1;
	u=dmatrix(0,nn,0,nn); // Allocate space for gradient matrix
	out = dmatrix(0,nn,0,nn);
	for (int i=1; i <= nn; i++) {
		for (int j=1; j <= nn; j++) {
			u[i][j] = ImageGetPixelf(divG, i - 1, j - 1, Width, Height);
		}
	}
	int Vcycles = 5;
	//solve linear equation
	mglin((double **) u,nn,Vcycles);
	imageNormalize(u, out, nn, nn);
	for(i = 1; i < Width - 1; i ++){
		for(int j = 1; j < Height -1; j++){
			result[j * Width + i] = (int)(out[i][j]);
		}
	}
	//clear memory
	free_dmatrix((double **) u, 0, nn, 0, nn);
	free_dmatrix((double **) out, 0, nn, 0, nn);
	delete [] divG;
	Invalidate(false);
}
void CPoissonImageDlg::OnBnClickedGradient()
{
	
	BYTE * channelr = new BYTE[Width * Height];
	BYTE * channelg = new BYTE[Width * Height];
	BYTE * channelb = new BYTE[Width * Height];
	double * gradHxfinal = new double [Width * Height];
	double * gradHyfinal = new double [Width * Height];

	//integrate rgb channel separately
	//first get gradient of the day
	imageGradient(rday, gradHxday, gradHyday, Width, Height);
	//then get the gradient of the night
	imageGradient(rnight, gradHxnight, gradHynight, Width, Height);
	//merge the gradient by a mask
	MergeGradient(gradHxnight, gradHynight, gradHxday, gradHyday, 
		gradHxfinal, gradHyfinal, mask, Width, Height);
	//integrate by solving the poisson equation
	IntegrateOneChannel(gradHxfinal, gradHyfinal, channelr);

	//same case for g and b

	imageGradient(gday, gradHxday, gradHyday, Width, Height);
	imageGradient(gnight, gradHxnight, gradHynight, Width, Height);
	MergeGradient(gradHxnight, gradHynight, gradHxday, gradHyday, 
		gradHxfinal, gradHyfinal, mask, Width, Height);
	IntegrateOneChannel(gradHxfinal, gradHyfinal, channelg);

	imageGradient(bday, gradHxday, gradHyday, Width, Height);
	imageGradient(bnight, gradHxnight, gradHynight, Width, Height);
	MergeGradient(gradHxnight, gradHynight, gradHxday, gradHyday, 
		gradHxfinal, gradHyfinal, mask, Width, Height);
	IntegrateOneChannel(gradHxfinal, gradHyfinal, channelb);

	for(int i = 0; i < Width; i ++){
		for(int j = 0; j < Height; j++){
			int pos = j * Widthbytes + 3 * i;
			int pos1 = j * Width + i;
			fused[pos] = channelr[pos1];
			fused[pos + 1] = channelg[pos1];
			fused[pos + 2] = channelb[pos1];
		}
	}
	delete[] gradHxfinal;
	delete[] gradHyfinal;

	Invalidate(false);
}


void CPoissonImageDlg::OnBnClickedGradx()
{
	// TODO: Add your control notification handler code here
	//show the horizontal gradient
	if(mask == NULL) return;
	imageGradient(rday, gradHxday, gradHyday, Width, Height);
	for(int i = 0; i < Width; i ++){
		for(int j = 0; j < Height; j++){
			//for debug
			int pos = j * Width + i;
			double absgrad = abs(gradHxday[pos]);
			if(absgrad > 255) absgrad = 255;
			mask[pos] = (int)(absgrad);
		}
	}
	Invalidate(false);
}

void CPoissonImageDlg::OnBnClickedGrady()
{
	// TODO: Add your control notification handler code here
	//show the vertical gradient
	if(mask == NULL) return;
	imageGradient(rday, gradHxday, gradHyday, Width, Height);
	for(int i = 0; i < Width; i ++){
		for(int j = 0; j < Height; j++){
			//for debug
			int pos = j * Width + i;
			double absgrad = abs(gradHyday[pos]);
			if(absgrad > 255) absgrad = 255;
			mask[pos] = (int)(absgrad);
		}
	}
	Invalidate(false);
}
