#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include <string.h>

#include "nrutil.h"

void mglin(double **u, int n, int ncycle);
void nrerror(char error_text[]);
float *vector(long nl, long nh);
int *ivector(long nl, long nh);
unsigned char *cvector(long nl, long nh);
unsigned long *lvector(long nl, long nh);
double *dvector(long nl, long nh);
float **matrix(long nrl, long nrh, long ncl, long nch);
double **dmatrix(long nrl, long nrh, long ncl, long nch);

enum {NORMALIZE, USEMAXMIN};
enum {MASK_OFF, MASK_ON};

void imageNormalize(double ** u, double **out, int width, int height);
BYTE ImageGetPixel(BYTE * image, int i, int j, int width, int height);
double ImageGetPixelf(double * gradHx, int i, int j, int width, int height);
void ImageSetPixelf(double * divG, int i, int j, double val, int width, int height);
void imageGradient(BYTE *image, double *gradHx, double *gradHy, int width, int height);
void MergeGradient(double * gradHx1, double * gradHy1, double * gradHx2, double * gradHy2, 
				   double * gradHxfinal, double * gradHyfinal, BYTE * mask, int width, int height);
void imageGradientTodivG(double *gradHx, double *gradHy, double *divG, int width, int height);
int compare( const void *elem1, const void *elem2 );
